
SCREENBUFFER1=$e000
SCREENBUFFER2=$e400
COLBUFFER=$d800
SCREENX=40
SCREENY=25

		.export _draw_mirror1
		.export _draw_mirror2
		.export _draw_colmirror

_draw_mirror1:

rts
;		sei
		dec $01
		ldx #0
@l1:
		.repeat (SCREENY/2),count
		lda SCREENBUFFER1+(count*SCREENX),x
		sta SCREENBUFFER1+(((SCREENY-1)-count)*SCREENX),x
		.endrepeat
		inx
		cpx #SCREENX
		bne @l1
		inc $01
;		cli
		rts

_draw_mirror2:

;		sei
		dec $01
		ldx #0
@l1:
		.repeat (SCREENY/2),count
		lda SCREENBUFFER2+(count*SCREENX),x
		sta SCREENBUFFER2+(((SCREENY-1)-count)*SCREENX),x
		.endrepeat
		inx
		cpx #SCREENX
		bne @l1
		inc $01
;		cli
		rts

_draw_colmirror:
		ldx #0
@l2:
;		.repeat (SCREENY/2),count
;		lda COLBUFFER+(count*SCREENX),x
;		sta COLBUFFER+(((SCREENY-1)-count)*SCREENX),x
;		.endrepeat
		lda COLBUFFER,x
		.repeat (SCREENY-1),count
		sta COLBUFFER+((count+1)*SCREENX),x
		.endrepeat
		inx
		cpx #SCREENX
		bne @l2

		rts

; a - x position
; x - line height

; - line texture

		.export _draw_line
		.export _draw_line1
		.importzp tmp1

		.import _col_project
		.import _wall_project
		.import _wall_project2
		.import _sky_project
		.import popa

_draw_line:
		sta @h+1
		tax
		lda _sky_project,x
		and #$0f
		tax

		lda lineshigh0,x
		sta @t+2
		lda lineslow0,x
		sta @t+1

		jsr popa
		sta @d+1
		jsr popa
		tay
		;;ldy tmp1 ;; get xpos
@d:		lda #0
		sta tmp1
@h:		ldx #0
@t:		jmp $dead

_draw_line1:
		sta @h+1
		tax
		lda _sky_project,x
		and #$0f
		tax

		lda lineshigh1,x
		sta @t+2
		lda lineslow1,x
		sta @t+1

		jsr popa
		sta @d+1
		jsr popa
		tay
		;;ldy tmp1 ;; get xpos
@d:		lda #0
		sta tmp1
@h:		ldx #0
@t:		jmp $dead

;		.align 256

.macro drawline buf,ycount

			lda #$1f	; sky tex
			.repeat ycount,ycount2
			sta buf+(SCREENX*ycount2),y
			sta buf+(SCREENX*(SCREENY-1))-(SCREENX*ycount2),y
			.endrepeat

			lda _wall_project,x
			cmp buf+(SCREENX*((ycount))),y
			beq @skp1
			sta buf+(SCREENX*((ycount))),y
			sta buf+(SCREENX*(SCREENY-1))-(SCREENX*ycount),y

			lda _wall_project2,x
			.repeat (SCREENY-(((ycount)*2)+2)),ycount2
			sta buf+(SCREENX*((ycount)+1))+(SCREENX*ycount2),y
			.endrepeat
@skp1:
			ldx tmp1
			lda _col_project,x
;			cmp COLCACHE,y
;			beq @skp
;			sta COLCACHE,y
			.repeat (SCREENY-(((ycount)*2))),ycount2
			sta COLBUFFER+(SCREENX*((ycount)))+(SCREENX*ycount2),y
			.endrepeat
@skp:
			.repeat ycount,ycount2
			lda _col_project+(ycount2*8)+ycount
;;			sta COLBUFFER+((SCREENY-(((ycount)*2)+2))*SCREENX)+(SCREENX*((ycount)+1))+(SCREENX*ycount2),y
			sta COLBUFFER+(SCREENX*(SCREENY-1))-(SCREENX*ycount2),y
			sta COLBUFFER+(SCREENX*ycount2),y
			.endrepeat
			rts
.endmacro

COLCACHE:
	.res SCREENX

_draw_lines0: drawline SCREENBUFFER1,0
_draw_lines1: drawline SCREENBUFFER1,1
_draw_lines2: drawline SCREENBUFFER1,2
_draw_lines3: drawline SCREENBUFFER1,3
_draw_lines4: drawline SCREENBUFFER1,4
_draw_lines5: drawline SCREENBUFFER1,5
_draw_lines6: drawline SCREENBUFFER1,6
_draw_lines7: drawline SCREENBUFFER1,7
_draw_lines8: drawline SCREENBUFFER1,8
_draw_lines9: drawline SCREENBUFFER1,9
_draw_lines10: drawline SCREENBUFFER1,10
_draw_lines11: drawline SCREENBUFFER1,11
_draw_lines12: drawline SCREENBUFFER1,11
_draw_lines13: drawline SCREENBUFFER1,11
_draw_lines14: drawline SCREENBUFFER1,11
_draw_lines15: drawline SCREENBUFFER1,11
_draw_lines16: drawline SCREENBUFFER1,11

_draw_linesB0: drawline SCREENBUFFER2,0
_draw_linesB1: drawline SCREENBUFFER2,1
_draw_linesB2: drawline SCREENBUFFER2,2
_draw_linesB3: drawline SCREENBUFFER2,3
_draw_linesB4: drawline SCREENBUFFER2,4
_draw_linesB5: drawline SCREENBUFFER2,5
_draw_linesB6: drawline SCREENBUFFER2,6
_draw_linesB7: drawline SCREENBUFFER2,7
_draw_linesB8: drawline SCREENBUFFER2,8
_draw_linesB9: drawline SCREENBUFFER2,9
_draw_linesB10: drawline SCREENBUFFER2,10
_draw_linesB11: drawline SCREENBUFFER2,11
_draw_linesB12: drawline SCREENBUFFER2,11
_draw_linesB13: drawline SCREENBUFFER2,11
_draw_linesB14: drawline SCREENBUFFER2,11
_draw_linesB15: drawline SCREENBUFFER2,11
_draw_linesB16: drawline SCREENBUFFER2,11



lineslow0:
	.byte < _draw_lines0
	.byte < _draw_lines1
	.byte < _draw_lines2
	.byte < _draw_lines3
	.byte < _draw_lines4
	.byte < _draw_lines5
	.byte < _draw_lines6
	.byte < _draw_lines7
	.byte < _draw_lines8
	.byte < _draw_lines9
	.byte < _draw_lines10
	.byte < _draw_lines11
	.byte < _draw_lines12
	.byte < _draw_lines13
	.byte < _draw_lines14
	.byte < _draw_lines15
	.byte < _draw_lines16

lineshigh0:
	.byte > _draw_lines0
	.byte > _draw_lines1
	.byte > _draw_lines2
	.byte > _draw_lines3
	.byte > _draw_lines4
	.byte > _draw_lines5
	.byte > _draw_lines6
	.byte > _draw_lines7
	.byte > _draw_lines8
	.byte > _draw_lines9
	.byte > _draw_lines10
	.byte > _draw_lines11
	.byte > _draw_lines12
	.byte > _draw_lines13
	.byte > _draw_lines14
	.byte > _draw_lines15
	.byte > _draw_lines16

lineslow1:
	.byte < _draw_linesB0
	.byte < _draw_linesB1
	.byte < _draw_linesB2
	.byte < _draw_linesB3
	.byte < _draw_linesB4
	.byte < _draw_linesB5
	.byte < _draw_linesB6
	.byte < _draw_linesB7
	.byte < _draw_linesB8
	.byte < _draw_linesB9
	.byte < _draw_linesB10
	.byte < _draw_linesB11
	.byte < _draw_linesB12
	.byte < _draw_linesB13
	.byte < _draw_linesB14
	.byte < _draw_linesB15
	.byte < _draw_linesB16

lineshigh1:
	.byte > _draw_linesB0
	.byte > _draw_linesB1
	.byte > _draw_linesB2
	.byte > _draw_linesB3
	.byte > _draw_linesB4
	.byte > _draw_linesB5
	.byte > _draw_linesB6
	.byte > _draw_linesB7
	.byte > _draw_linesB8
	.byte > _draw_linesB9
	.byte > _draw_linesB10
	.byte > _draw_linesB11
	.byte > _draw_linesB12
	.byte > _draw_linesB13
	.byte > _draw_linesB14
	.byte > _draw_linesB15
	.byte > _draw_linesB16
