
	.export _startirq
	.export _stopirq

_startirq:
	sei
	lda #>irq1
	sta $0315
	sta $ffff
	lda #<irq1
	sta $0314
	sta $fffe
	lda #$7f
	sta $dc0d
	lda #$01
	sta $d01a
	lda #$1b
	sta $d011
	lda #$30
	sta $d012
	lda #$00
	sta irqcnt
	cli
	rts

_stopirq:

	sei
	lda #$ea
	sta $0315
	lda #$31
	sta $0314
	inc $d019
	lda #$81
	sta $dc0d
	lda #$00
	sta $d01a
	cli
	rts

irqcnt:
	.byte 0

cols:
	.byte $01 ;; first
	.byte $0d,$03,$05,$0e,$04,$0b,$06,$00
	.byte $00 ;; middle of screen
	.byte $09,$02,$08,$0c,$0a,$0f,$07,$01
char:
	.byte $0c
	.byte $0c,$0c,$0c,$0c,$0c,$0c,$0c,$0c
	.byte $0a
	.byte $0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a
;nextline:
;	.byte $96-8-103,$96-8-68,$96-8-46,$96-8-30,$96-8-20,$96-8-14,$96-8-9,$96-8-4
;	.byte $96;; middle of screen
;	.byte $96+4+4+4,$96+4+4+9,$96+4+4+14,$96+4+4+20,$96+4+4+30,$96+4+4+46,$96+4+4+68,$96+2+103
;	.byte $0 ;; first

.macro linetab offs

	;.byte 4

	.repeat 8,count
;;	.byte ($96-8-103)+(((count*8)+offs)*2)
	.byte $96+$10-($700/((((count+2)*8)+(7-offs))*1))
	.endrepeat

	.byte $96;; middle of screen

	.repeat 8,count
;	.byte ($96+4+4+4)+(((count*8)+offs)*1)
	.byte $96-$10+($700/((((9-count)*8)+(7-offs))*1))
	.endrepeat

	;;.byte $e8
	;;.byte $f0
	;;.byte $ff
	.byte $0 ;; first
.endmacro

nextline:	linetab 0
nextline1:	linetab 1
nextline2:	linetab 2
nextline3:	linetab 3
nextline4:	linetab 4
nextline5:	linetab 5
nextline6:	linetab 6
nextline7:	linetab 7

	.export _irqincoffs
	.export _irqdecoffs
_irqincoffs:
@l:	lda #0
	inc @l+1
	and #$7
	tax
	lda offsh,x
	sta line+2
	lda offsl,x
	sta line+1
	rts
_irqdecoffs:
@l:	lda #0
	dec @l+1
	and #$7
	tax
	lda offsh,x
	sta line+2
	lda offsl,x
	sta line+1
	rts

offsh:
	.byte >nextline
	.byte >nextline1
	.byte >nextline2
	.byte >nextline3
	.byte >nextline4
	.byte >nextline5
	.byte >nextline6
	.byte >nextline7
offsl:
	.byte <nextline
	.byte <nextline1
	.byte <nextline2
	.byte <nextline3
	.byte <nextline4
	.byte <nextline5
	.byte <nextline6
	.byte <nextline7

irq1:

	pha
	txa
	pha
;;inc $d020
	ldx irqcnt
	lda cols,x
	sta $d021
;	sta $d020
	lda $d018
	and #$f0
	ora char,x
	sta $d018
line:	lda nextline,x
	sta $d012
	lda #$1b
	sta $d011

	inx
	cpx #16+2
	beq waslast

	stx irqcnt

	inc $d019

	lda $01
	cmp #$35
	beq @l

	pla
	tax
	pla
	jmp $ea81

@l:
	pla
	tax
	pla
	rti

waslast:
	ldx #0
	stx irqcnt

	inc $d019

	lda $01
	cmp #$35
	beq @l

	pla
	tax
	pla
	jmp $ea31

@l:
	pla
	tax
	pla
	rti
